// $Id: MSXMemDevice.cc,v 1.5 2002/03/19 20:38:06 m9710797 Exp $
 
#include "MSXMotherBoard.hh"
#include "MSXMemDevice.hh"


MSXMemDevice::MSXMemDevice(MSXConfig::Device *config, const EmuTime &time)
	: MSXDevice(config, time)
{
	registerSlots();
}

byte MSXMemDevice::readMem(word address, const EmuTime &time)
{
	return 255;
}

void MSXMemDevice::writeMem(word address, byte value, const EmuTime &time)
{
	// do nothing
}

void MSXMemDevice::registerSlots()
{
	// register in slot-structure
	if (deviceConfig==NULL) return;	// for DummyDevice
	std::list<MSXConfig::Device::Slotted*>::const_iterator i;
	for (i=deviceConfig->slotted.begin(); i!=deviceConfig->slotted.end(); i++) {
		int ps=(*i)->getPS();
		int ss=(*i)->getSS();
		int page=(*i)->getPage();
		MSXMotherBoard::instance()->registerSlottedDevice(this,ps,ss,page);
	}
}

byte* MSXMemDevice::getReadCacheLine(word start)
{
	return NULL;
}

byte* MSXMemDevice::getWriteCacheLine(word start)
{
	return NULL;
}
